#include <tigcclib.h>

void cprght()
{
	puts("The Love Calculator: \nhttp://www.lovecalculator.com/\n");
	puts("By Thijs Kinkhorst & Matthijs Sypkens Smit\n");
	puts("UNIX Version by Bartek Kania\n");
	puts("Adapted for TI68ks by Malcolm Smith\n\n");
}


/*
 * TI Specific Addition: String input routine
 * (Malcolm Smith) - From the TIGCC FAQ
 */
void InputStr(char *buffer, unsigned short maxlen)
{
  SCR_STATE ss;
  short key;
  unsigned short i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_   ", buffer);
      key = ngetchx ();
      if (key >= ' ' && key <= '~' && i < maxlen)
        buffer[i++] = key;
      else if (key == KEY_BACKSPACE && i)
        i--;
      buffer[i] = 0;
    } while (key != KEY_ENTER);
    buffer[i] = '\n';
    buffer[++i] = 0;
}


/*
 * Get a name from the user
 * Edit by Malcolm Smith: strdup call removed, tmp->static
 */
char *getname(const char * const pr)
{
	static char name[100];

	memset(name,0,100);
	printf("%s: ", pr);
	InputStr(name, 100);
	printf("\n\n");
	return(name);
}

/*
 * Count the occurance of the different letters
 * Edit by Malcolm Smith: tmp2->tmp2[20],
 * tmp2=strdup(tmp) changed to strcpy(tmp2,strdup(tmp))
 * tmp made static
 */
char *trans_names(char *p1, char *p2)
{
	const char *letters="LOVES";
	static char tmp[20];
	char tmp2[100];
	int j, i, n, c;

	memset(tmp,0,20);
	n=strlen(letters);
	for(j=0; j<n; j++) {
		i=0; c=0;
		while(p1[i] && p1[i]!='\n') {
			if(toupper(p1[i])==letters[j]) c++;
			i++;
		}
		i=0;
		while(p2[i] && p2[i]!='\n') {
			if(toupper(p2[i])==letters[j]) c++;
			i++;
		}
		strcpy(tmp2,tmp);
		sprintf(tmp,"%s%u", tmp2, c);
	}
	return(tmp);
}

/*
 * Calculate the chance of success
 */
int calculate(char *score)
{
	int last[100];
	char scr[64], tmp[64]="", tmp2[64];
	int sc, i, n=0;
	
	memset(last, 0, 100);
	strcpy(scr, score);
	
	while(strlen(scr)>2) {
		/* Check if we have seen this score before.. If we have, abort
		   and return 0 */
		sc=atoi(scr);
		for(i=0; i<100; i++) if(sc==last[n]) return 0;

		/* In any case, if we have done this more than a hundred times,
		   or the number has expanded to over 30 digits, abort */
		if(n>99) return 0;
		if(strlen(scr)>30) return 0;
		
		i=0;
		tmp[0]=0;
		while(scr[i+1] && scr[i+1]!='\n') {
			sc=(scr[i]-48)+(scr[i+1]-48);
			strcpy(tmp2,tmp);
			sprintf(tmp, "%s%u", tmp2, sc);
			i++;
		}
		strcpy(scr, tmp);
		last[n]=atoi(scr);
		n++;
	}
	return(atoi(scr));
}

//Edited extensively by Malcolm Smith
void _main(void)
{
	char p1[100], p2[100], score[100];
	int chance;
	
	FontSetSys(F_4x6);
	clrscr();
	cprght();
	
	strcpy(p1,getname("Enter name 1 (FULL)\n"));
	strcpy(p2,getname("Enter name 2 (FULL)\n"));

	strcpy(score,trans_names(p1,p2));
	chance=calculate(score);
	printf("\nThe chance of a successful relationship is %u%%\n",chance);
	ngetchx();
}
